"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LocationPage = void 0;
require("core-js/modules/web.dom-collections.iterator.js");
require("core-js/modules/es.json.stringify.js");
require("core-js/modules/es.promise.js");
var _react = _interopRequireWildcard(require("react"));
var _ = require("..");
var _reactSelect = _interopRequireDefault(require("react-select"));
var _svgs = require("../svgs");
require("./LocationPage.css");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
const LocationPage = _ref => {
  let {
    url = "#",
    redirectEvent
  } = _ref;
  const [selectedState, setSelectedState] = (0, _react.useState)();
  const [currentStep, setCurrentStep] = (0, _react.useState)(0);
  const [termsAccepted, setTermsAccepted] = (0, _react.useState)(false);
  const privK = "CoalitionSpinPremiaState";
  const chihuahuaToken = '{"value":"Chihuahua","label":"Chihuahua"}';
  const lon = ["Aguascalientes", "Baja California", "Baja California Sur", "Chihuahua", "Colima", "Campeche", "Coahuila", "Chiapas", "Ciudad de México", "Durango", "Guerrero", "Guanajuato", "Hidalgo", "Jalisco", "Estado de México", "Michoacán", "Morelos", "Nayarit", "Nuevo León", "Oaxaca", "Puebla", "Querétaro", "Quintana Roo", "Sinaloa", "San Luis Potosí", "Sonora", "Tabasco", "Tlaxcala", "Tamaulipas", "Veracruz", "Yucatán", "Zacatecas"];
  const buildMexicoStates = function buildMexicoStates() {
    let res = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    for (let i = 0; i < lon.length; i++) res.push({
      value: lon[i],
      label: lon[i]
    });
    return res;
  };
  const states = buildMexicoStates();
  const storeState = () => {
    localStorage.setItem(privK, JSON.stringify(selectedState));
    setCurrentStep(1);
  };
  const isChihuahua = () => JSON.stringify(selectedState) === chihuahuaToken;
  (0, _react.useEffect)(() => {
    if (!selectedState) {
      const stored = localStorage.getItem(privK);
      if (stored && stored !== JSON.stringify(selectedState)) setSelectedState(JSON.parse(stored));
    }
  }, [selectedState]);
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("div", {
    className: "location-page-container"
  }, currentStep === 0 ? /*#__PURE__*/_react.default.createElement(LocationForm, {
    states: states,
    selectedState: selectedState,
    storeState: storeState,
    setSelectedState: setSelectedState
  }) : null, currentStep === 1 && isChihuahua() ? /*#__PURE__*/_react.default.createElement(ChihuahuaPicked, {
    url: url,
    termsAccepted: termsAccepted,
    setTermsAccepted: setTermsAccepted
  }) : null));
};
exports.LocationPage = LocationPage;
const ChihuahuaPicked = _ref2 => {
  let {
    url,
    termsAccepted,
    setTermsAccepted
  } = _ref2;
  const [currentSwap, setCurrentSwap] = (0, _react.useState)(0);
  const swapIdx = delta => {
    console.log(["ChihuahuaPicked", currentSwap, delta, currentSwap + delta]);
    setCurrentSwap(currentSwap + delta);
  };
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, currentSwap === 0 ? /*#__PURE__*/_react.default.createElement(NewBenefits, {
    swapIdx: swapIdx
  }) : null, currentSwap === 1 ? /*#__PURE__*/_react.default.createElement(WayToPay, {
    swapIdx: swapIdx,
    url: url,
    termsAccepted: termsAccepted,
    setTermsAccepted: setTermsAccepted
  }) : null);
};
const LocationForm = _ref3 => {
  let {
    states,
    selectedState,
    storeState,
    setSelectedState
  } = _ref3;
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("div", {
    className: "location-page-container-banner"
  }, /*#__PURE__*/_react.default.createElement(_svgs.LocationBanner, null)), /*#__PURE__*/_react.default.createElement("div", {
    className: "location-page-container-form"
  }, /*#__PURE__*/_react.default.createElement(_.CoalitionComponents.CoalitionSlide, {
    className: "vertical-center",
    title: "Personaliza tus beneficios",
    description: "Elige el estado de la república en el que te encuentras",
    buttonLabel: "Continuar",
    valid: selectedState != null,
    submitFunction: storeState
  }, /*#__PURE__*/_react.default.createElement(_reactSelect.default, {
    className: "coalition-slide-location-dropdown"
    // classNamePrefix="select"
    // defaultValue={defVal}
    ,
    isDisabled: false,
    isLoading: false,
    isClearable: false,
    isRtl: false,
    isSearchable: false,
    name: "state",
    options: states,
    value: selectedState,
    onChange: setSelectedState
  }))));
};
const NewBenefits = _ref4 => {
  let {
    swapIdx
  } = _ref4;
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("div", {
    className: "location-page-container-banner-desktop"
  }, /*#__PURE__*/_react.default.createElement(_svgs.CupGuysDesktop, null)), /*#__PURE__*/_react.default.createElement("div", {
    className: "location-page-container-banner-mobile"
  }, /*#__PURE__*/_react.default.createElement(_svgs.CupGuysMobile, null)), /*#__PURE__*/_react.default.createElement("div", {
    className: "location-page-container-form"
  }, /*#__PURE__*/_react.default.createElement(_.CoalitionComponents.CoalitionSlide, {
    className: "vertical-center",
    title: "Disfruta tus nuevos beneficios",
    description: "Ahora un punto vale $0.20 y puedes usarlos en cualquier tienda OXXO",
    buttonLabel: "Continuar",
    valid: true,
    submitFunction: () => swapIdx(1)
  })));
};
const WayToPay = _ref5 => {
  let {
    swapIdx,
    url,
    termsAccepted,
    setTermsAccepted
  } = _ref5;
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("div", {
    className: "location-page-container-banner-desktop"
  }, /*#__PURE__*/_react.default.createElement(_svgs.GiftGuysDesktop, null)), /*#__PURE__*/_react.default.createElement("div", {
    className: "location-page-container-banner-mobile"
  }, /*#__PURE__*/_react.default.createElement(_svgs.GiftGuysMobile, null)), /*#__PURE__*/_react.default.createElement("div", {
    className: "location-page-container-form"
  }, /*#__PURE__*/_react.default.createElement(_.CoalitionComponents.CoalitionSlide, {
    className: "vertical-center",
    title: "Paga de manera total o parcial",
    description: "Usa tus puntos disponibles en tu cuenta para comprar tus productos favoritos",
    buttonLabel: "Continuar",
    valid: termsAccepted !== false,
    submitFunction: () => swapIdx(1)
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "coalition-slide-location-terms-conditions"
  }, /*#__PURE__*/_react.default.createElement("input", {
    type: "checkbox",
    id: "termsConditions",
    name: "termsConditions",
    value: termsAccepted,
    onChange: async () => await setTermsAccepted(!termsAccepted)
  }), /*#__PURE__*/_react.default.createElement("label", {
    htmlFor: "termsConditions"
  }, "Le\xED y acepto los", " ", /*#__PURE__*/_react.default.createElement("a", {
    className: "location-page-container-link",
    href: url,
    target: "_blank",
    rel: "noreferrer"
  }, "T\xE9rminos y condiciones"), " ", "del programa de lealtad")))));
};